/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BigNumber,
  BigNumberish,
  BytesLike,
  CallOverrides,
  ContractTransaction,
  Overrides,
  PopulatedTransaction,
  Signer,
  utils,
} from "ethers";
import type { FunctionFragment, Result } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type {
  TypedEventFilter,
  TypedEvent,
  TypedListener,
  OnEvent,
  PromiseOrValue,
} from "../../../common";

export interface SlotNFTConditionInterface extends utils.Interface {
  functions: {
    "OSP()": FunctionFragment;
    "condition(address,bytes)": FunctionFragment;
    "isCommunitySlotWhitelisted(address)": FunctionFragment;
    "isSlotNFTUsable(address,address,uint256)": FunctionFragment;
    "whitelistCommunitySlot(address,bool)": FunctionFragment;
  };

  getFunction(
    nameOrSignatureOrTopic:
      | "OSP"
      | "condition"
      | "isCommunitySlotWhitelisted"
      | "isSlotNFTUsable"
      | "whitelistCommunitySlot"
  ): FunctionFragment;

  encodeFunctionData(functionFragment: "OSP", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "condition",
    values: [PromiseOrValue<string>, PromiseOrValue<BytesLike>]
  ): string;
  encodeFunctionData(
    functionFragment: "isCommunitySlotWhitelisted",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "isSlotNFTUsable",
    values: [
      PromiseOrValue<string>,
      PromiseOrValue<string>,
      PromiseOrValue<BigNumberish>
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "whitelistCommunitySlot",
    values: [PromiseOrValue<string>, PromiseOrValue<boolean>]
  ): string;

  decodeFunctionResult(functionFragment: "OSP", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "condition", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "isCommunitySlotWhitelisted",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "isSlotNFTUsable",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "whitelistCommunitySlot",
    data: BytesLike
  ): Result;

  events: {};
}

export interface SlotNFTCondition extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  interface: SlotNFTConditionInterface;

  queryFilter<TEvent extends TypedEvent>(
    event: TypedEventFilter<TEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TEvent>>;

  listeners<TEvent extends TypedEvent>(
    eventFilter?: TypedEventFilter<TEvent>
  ): Array<TypedListener<TEvent>>;
  listeners(eventName?: string): Array<Listener>;
  removeAllListeners<TEvent extends TypedEvent>(
    eventFilter: TypedEventFilter<TEvent>
  ): this;
  removeAllListeners(eventName?: string): this;
  off: OnEvent<this>;
  on: OnEvent<this>;
  once: OnEvent<this>;
  removeListener: OnEvent<this>;

  functions: {
    OSP(overrides?: CallOverrides): Promise<[string]>;

    condition(
      to: PromiseOrValue<string>,
      data: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    isCommunitySlotWhitelisted(
      slot: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    isSlotNFTUsable(
      slot: PromiseOrValue<string>,
      addr: PromiseOrValue<string>,
      tokenId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    whitelistCommunitySlot(
      slot: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;
  };

  OSP(overrides?: CallOverrides): Promise<string>;

  condition(
    to: PromiseOrValue<string>,
    data: PromiseOrValue<BytesLike>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  isCommunitySlotWhitelisted(
    slot: PromiseOrValue<string>,
    overrides?: CallOverrides
  ): Promise<boolean>;

  isSlotNFTUsable(
    slot: PromiseOrValue<string>,
    addr: PromiseOrValue<string>,
    tokenId: PromiseOrValue<BigNumberish>,
    overrides?: CallOverrides
  ): Promise<boolean>;

  whitelistCommunitySlot(
    slot: PromiseOrValue<string>,
    whitelist: PromiseOrValue<boolean>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  callStatic: {
    OSP(overrides?: CallOverrides): Promise<string>;

    condition(
      to: PromiseOrValue<string>,
      data: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<void>;

    isCommunitySlotWhitelisted(
      slot: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    isSlotNFTUsable(
      slot: PromiseOrValue<string>,
      addr: PromiseOrValue<string>,
      tokenId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    whitelistCommunitySlot(
      slot: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: CallOverrides
    ): Promise<void>;
  };

  filters: {};

  estimateGas: {
    OSP(overrides?: CallOverrides): Promise<BigNumber>;

    condition(
      to: PromiseOrValue<string>,
      data: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    isCommunitySlotWhitelisted(
      slot: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    isSlotNFTUsable(
      slot: PromiseOrValue<string>,
      addr: PromiseOrValue<string>,
      tokenId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    whitelistCommunitySlot(
      slot: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    OSP(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    condition(
      to: PromiseOrValue<string>,
      data: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    isCommunitySlotWhitelisted(
      slot: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    isSlotNFTUsable(
      slot: PromiseOrValue<string>,
      addr: PromiseOrValue<string>,
      tokenId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    whitelistCommunitySlot(
      slot: PromiseOrValue<string>,
      whitelist: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;
  };
}
